/* Ejemplo1.c -> Creacion de una ventana con un pixmap de fondo. */
/* gcc -o ejemplo1 ejemplo1.c -lX11 -L/usr/X11R6/lib             */

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/bitmaps/xlogo64>

unsigned long ColorPorNombre( Display *, char *);

/*---------------------------------------------------------------------*/
void main(int  argc, char **argv)
{
  Display *display;
  Window ventana;
  int pantalla;
  int profundidad, clase;
  int x, y, ancho, alto, colorfondo, colorfore;
  Visual *visual;
  Pixmap pixmapfondo;
  XSetWindowAttributes atrib;      /* atributos de las ventanas */
  unsigned long mascara;

  display= XOpenDisplay(NULL);
  pantalla=DefaultScreen(display);

  x=y=200;
  ancho=alto=300;
  profundidad=CopyFromParent;
  visual=DefaultVisual(display, pantalla);
  clase=InputOutput;
  colorfondo = ColorPorNombre(display, "red");
  colorfore  = ColorPorNombre(display, "green");

  pixmapfondo= XCreatePixmapFromBitmapData(display,RootWindow(display, pantalla),
               xlogo64_bits, xlogo64_width, xlogo64_height,colorfore, colorfondo,
               DefaultDepth(display, pantalla));

  /* Asociamos el pixmap al fondo de la ventana. Este atributo de la ventana
     lo estableceremos con XCreateWindow() indicandole que queremos que la
     ventana tenga un pixmap de fondo. */
  atrib.background_pixmap=pixmapfondo;

  /* Mscara sirve para indicarle a CreateWindow qu parametros de la
     ventana queremos especificar desde XSetWindowAttributes (atrib)*/
  mascara= CWBackPixmap;
  ventana= XCreateWindow(display, RootWindow(display, pantalla),
           x , y, ancho, alto, 2, profundidad, clase, visual,
           mascara, &atrib);
  XMapWindow(display, ventana);
  XFlush(display);
  getchar();
  XCloseDisplay(display);
}

/*--- Rutina para localizar colores por nombre ----------------*/
unsigned long ColorPorNombre( Display *display, char *Nombre )
{
  XColor color, temp;
  XAllocNamedColor( display,
     DefaultColormap(display,DefaultScreen(display)),
     Nombre, &color, &temp );
  return( color.pixel );
}
