/* Ejemplo2.c -> Ejemplo extrado de un tutorial de Xlib en Internet. */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include <stdio.h>

unsigned long Color( Display *, char *);

/*-------------------------------------------------------------------*/
void main()
{
  Display *d;
  Window w;
  GC gc;
  unsigned long azul, blanco, naranja, negro, rojo, verde;
  XSetWindowAttributes atributos;

  XPoint lineas1[] =
  {
      { 200,300 }, { 250,200 }, { 300,250 }, { 350,100 }, { 400,300 }
  };

    XPoint lineas2[] =
  {
        { 200,50 }, { 450,50 }, { 450, 375 }
  };

    XSegment segmentos[] =
   {
        { 50,200,100,300 }, { 100,150,50,300 }, { 150,100,150,300 }
   };

    char patron[] = { 20, 5, 10, 15 };

    d = XOpenDisplay( NULL );

    azul    = Color( d, "blue"   ); blanco = Color( d, "white" );
    naranja = Color( d, "orange" ); negro  = Color( d, "black" );
    rojo    = Color( d, "red"    ); verde  = Color( d, "green" );

    w = XCreateSimpleWindow( d, DefaultRootWindow( d ), 100, 200,
                             500, 400, 10, negro, blanco );
    atributos.override_redirect = True; /* para puentear al WM */
    XChangeWindowAttributes( d, w, CWOverrideRedirect, &atributos );

    XMapWindow( d, w );

    gc = XCreateGC( d, w, 0, NULL );

    XSetForeground( d, gc, negro );
    XSetLineAttributes( d, gc, 4, LineSolid, CapButt, 0 );
    XDrawLine( d, w, gc, 50, 350, 450, 350 );

    XSetForeground( d, gc, azul );
    XSetBackground( d, gc, verde );
    XSetLineAttributes( d, gc, 8, LineDoubleDash, CapButt, 0);
    XDrawSegments( d, w, gc, segmentos, 3 );

    XSetLineAttributes( d, gc, 15, LineSolid, CapRound, JoinRound );
    XDrawLines( d, w, gc, lineas1, 5, CoordModeOrigin );

    XSetForeground( d, gc, naranja );
    XSetBackground( d, gc, verde );
    XSetLineAttributes( d, gc, 20, LineDoubleDash, CapProjecting, JoinBevel );
    XDrawLines( d, w, gc, lineas2, 3, CoordModeOrigin );

    XFlush( d );
    getchar();
 }

/*--- Rutina para localizar colores por nombre ----------------*/
unsigned long Color( Display *display, char *Nombre )
{
  XColor color, temp;
  XAllocNamedColor( display,
     DefaultColormap(display,DefaultScreen(display)),
     Nombre, &color, &temp );
  return( color.pixel );
}
